//Created: 23.01.97
//Ported to 32 bit: 21.02.97
//Last Update: 06.02.97
//
unit UFontBank32;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Spin, StdCtrls, ExtCtrls, Buttons, HMPanel, ComCtrls, Menus, Printers,
  TrayIcon;

type
  TWFontBank32 = class(TForm)
    popFontBank32: TPopupMenu;
      About1: TMenuItem;
      N1: TMenuItem;
      Exit1: TMenuItem;
      N2: TMenuItem;
      Maximize1: TMenuItem;
      Hide1: TMenuItem;

    pagFonts: TPageControl;
      sheFontList: TTabSheet;
      sheAttribute: TTabSheet;
      sheAbout: TTabSheet;

    panBackList: THMPanel;
    panSample: THMPanel;
    panBackAttrib: THMPanel;
    panBackAbout: THMPanel;
    panList: THMPanel;
    panMemoAttrib: THMPanel;
    panMemo: THMPanel;

    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;

    bitScreen: TBitBtn;
    bitPrinter: TBitBtn;
    bitExit: TBitBtn;

    memFont: TMemo;
    memAbout: TMemo;

    radStyle: TRadioGroup;

    cmbColor: TComboBox;

    sedSpin: TSpinEdit;

    lstFontList: TListBox;

    ediFont: TEdit;

    procedure bitScreenClick(Sender: TObject);
    procedure bitPrinterClick(Sender: TObject);
    procedure bitExitClick(Sender: TObject);
    procedure sedSpinChange(Sender: TObject);
    procedure radStyleClick(Sender: TObject);
    procedure cmbColorChange(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure lstFontListClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure pagFontsChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Hide1Click(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure Maximize1Click(Sender: TObject);
    procedure ediFontKeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
    procedure WMGetMinMaxInfo(var MSG: TMessage); message WM_GetMinMaxInfo;
  public
    { Public declarations }
    procedure Information;
  end;

var
  WFontBank32: TWFontBank32;

implementation

uses UInvisible;

{$R *.DFM}


//~~~~~~~~~~~~~~~~~~~ User Defined Procs ~~~~~~~~~~~~~~~~ Start
//~~~~
//~~~~ WMGetMinMaxInfo
//~~~~
//~~~~ Using the following procedure the form minimum ans maimum size can
//~~~~ be set/Controled
procedure TWFontBank32.WMGetMinMaxInfo(var MSG: TMessage);
begin
     inherited;
     if PixelsPerInch = 96 then
        with PMinMaxInfo(MSG.lparam)^ do begin
             with ptMinTrackSize do begin
                  X := 410;
                  Y := 320;
                  end;
             end
     else if PixelsPerInch = 120 then
          with PMinMaxInfo(MSG.lparam)^ do begin
               with ptMinTrackSize do begin
                    X := 480;
                    Y := 400;
                    end;
               end
end;


//~~~~ Information
//~~~~
//~~~~ Used to do the slavery job
procedure TWFontBank32.Information;
begin
     memFont.Clear;
     memFont.Lines.Add('Font Name:   '+ lstFontList.Items[lstFontList.ItemIndex]);
     memFont.Lines.Add('Font Style:   '+ radStyle.Items[radStyle.ItemIndex]);
     memFont.Lines.Add('Font Size:   '+ IntToStr(sedSpin.Value));
     memFont.Lines.Add('Font Color:   '+ cmbColor.Text);
end;
//---->>>>
//~~~~~~~~~~~~~~~~~~~ User Defined Procs ~~~~~~~~~~~~~~~~ Finish


//~~~~~~~~~~~~~~~~~~~ Form Events ~~~~~~~~~~~~~~~~ Start
//~~~~ OnCreate
procedure TWFontBank32.FormCreate(Sender: TObject);
var
   N: Integer;
   N_STR: String;
begin
{String resources}
{
 1, "  Germany, Penzberg, 23.02.1997"
 2, "  A heavy rain is falling. She's 02:00 a.m. in the morning. It's cold and I can't sleep. Something is ringing in my head. I start my PC and after a long wait I'm ready."
 3, "  The idea had been floating in my brain for a long time. I needed such a program, but how to make it, was a big challenge. I knew I could do it, but the only dark spot in my head was... HOW !"
 4, "  I started without having a clear picture of what I was doing, but at that time things were falling exactly into the right place, just like an automatic puzzle ! Of course, the road was longer than I had expected ..."
 5, "  **********************"
 6, "  Of course, this could be a nice scenario for a science fiction book, but I assure you that I didn't start to write the program exactly the way the fictional story is describing."
 7, "  Anyway, who cares about the story or history of this application except me, so it is better to talk about the application and not its history."
 8, "  I called the application FontBank32\251, just because I liked it ! Well, of course, the application could be counted as some kind of bank, but not the one you usually see around."
 9, "  FontBank32\251 is an application that finds your installed fonts and shows you a graphical sample on a panel. It also gives you some very basic information about the font and enables you to change the font attributes and see the graphical results."
 10, "  It does nothing else ! That's why it is a Freeware! You can own it, use it and make copies for friends and relatives."
 11, "  BUT YOU CANNOT SELL IT."
 12, "  Working with FontBank32\251 is that easy that any Green Head(!) can use it, so it really doesn't need a help file. That's why I didn't write one."
 13, "  Neither does it need a lot of space on your Towers ! It doesn't have a lot of dependency files, either."
 14, "  It doesn't need to be installed, registered in the Windows System Registry Database and so on. You just need to copy it somewhere and run it."
 15, "  Just because of its simplicity, I think, it's also bug-free. You find one, put it in a jar and send it over."
 16, "  Of course, this is Version 1.0.32 . I have further plans for FontBank32\251 and it is possible in the future, if I have time and lust(!), that I release version 2.0.32, which will be more functional."
 17, "  I release it now just for one sake: I want to find out if there are some people who really need such an application and that's why I am going to ask for a favour."
 18, "  Please send me an e-Mail or a postcard in case you liked the application, you didn't like the application or you expected some special function you wished for, if you find any Bugs, etc."
 19, "  My address is:"
 20, "  HelpMakers"
 21, "  Alex Wernhardt"
 22, "  Saelweiherstr. 14"
 23, "  D-82377 Penzberg"
 24, "  Germany"
 25, "  e-Mail: HelpMakers@t-online.de"
 26, "  I also got a phone like most of the other people, but I ain't like talking on the phone so much, so you'd better write some lines."
 27, "  If you are interested in writing Windows applications in Delphi Pascal or Visual Basic, I would be delighted to hear from you."
 28, "  If you are wandering around trying to find some solutions for your problems, well, as the logo says: we (me and my shadow and my PCs) are here to help."
 29, "  After all we are HelpMakers."
 30, "  If you need the source code of FontBank32\251, It is included. Please respect the copyright and do not change anything. If you like to develop FontBank32 to a better software, please inform me."
 31, "  Before I forget: HelpMakers and Alex Wernhardt are not taking ANY type of responsiblity for whatever might happen to you, your software and/or hardware by using FontBank32\251. The responsiblity is on your shoulders !"
 32, "  Hope you like FontBank32\251."
 33, "  1997, Alex Wernhardt, HelpMakers."
}
     If PixelsPerInch = 96 then begin
        bitScreen.Height := 40;
        bitScreen.Width := 55;
        bitPrinter.Height := 40;
        bitPrinter.Width := 55;
        bitExit.Height := 40;
        bitExit.Width := 55;
        end
     else If PixelsPerInch = 120 then begin
          Font.Size := 7;
          bitScreen.Height := 46;
          bitScreen.Width := 63;
          bitPrinter.Height := 46;
          bitPrinter.Width := 63;
          bitExit.Height := 46;
          bitExit.Width := 63;
          end;

     lstFontList.Clear;
     lstFontList.Items := Screen.Fonts;
     lstFontList.ItemIndex := 0;
     panSample.Caption := ediFont.Text;
     panSample.Font.Name := lstFontList.Items[0];
     panSample.Font.Size := sedSpin.Value;
     Information;

     for N := 1 to 18 do begin
        N_STR := LoadStr(N);
        memAbout.Lines.Add(N_STR + #13#10);
        end;

     for N := 19 to 23 do begin
        N_STR := LoadStr(N);
        memAbout.Lines.Add(N_STR);
        end;

     for N := 24 to 33 do begin
        N_STR := LoadStr(N);
        memAbout.Lines.Add(N_STR + #13#10);
        end;

     Resize;
end;

//~~~~ OnHide
procedure TWFontBank32.FormHide(Sender: TObject);
begin
     Invisible.Show1.Caption := 'Show';
end;


//~~~~ OnResize
procedure TWFontBank32.FormResize(Sender: TObject);
begin
     bitPrinter.Left := panList.Left + panList.Width - bitPrinter.Width;
     bitScreen.Left := bitPrinter.Left - bitScreen.Width - 5;
     bitExit.Left := panMemo.Left + panMemo.Width - bitExit.Width;
end;
//---->>>>
//~~~~~~~~~~~~~~~~~~~ Form Events ~~~~~~~~~~~~~~~~ Finish


//~~~~~~~~~~~~~~~~~~~ Form Popup Menu(s) ~~~~~~~~~~~~~~~~ Start
//#### About1
procedure TWFontBank32.About1Click(Sender: TObject);
begin
     pagFonts.ActivePage := sheAbout;
     pagFonts.OnChange(Self);      // To fix the Exit Button's Position
end;
//---->>>>


//#### Exit1
procedure TWFontBank32.Exit1Click(Sender: TObject);
begin
     Application.Terminate;
end;
//---->>>>


//#### Maximize1
procedure TWFontBank32.Maximize1Click(Sender: TObject);
begin
     If Maximize1.Caption = 'Maximize' then begin
        WindowState := wsMaximized;
        Maximize1.Caption := 'Normal';
        end
     else If Maximize1.Caption = 'Normal' then begin
          panSample.Font.Size := 48;
          sedSpin.Value := 48;
          WindowState := wsNormal;
          Maximize1.Caption := 'Maximize';
        end;
end;
//---->>>>


//#### Hide1
procedure TWFontBank32.Hide1Click(Sender: TObject);
begin
     Hide;
end;
//---->>>>
//~~~~~~~~~~~~~~~~~~~ Form Popup Menu(s) ~~~~~~~~~~~~~~~~ Finish


//~~~~~~~~~~~~~~~~~~~ Form Objects ~~~~~~~~~~~~~~~~ Start
//#### bitPrinter -> OnClick
procedure TWFontBank32.bitPrinterClick(Sender: TObject);
begin
     lstFontList.Clear;
     lstFontList.Items := Printer.Fonts;
     lstFontList.ItemIndex := 0;
     panSample.Caption := ediFont.Text;
     panSample.Font.Name := lstFontList.Items[0];
     lstFontList.SetFocus;
end;
//---->>>>


//#### bitScreen -> OnClick
procedure TWFontBank32.bitScreenClick(Sender: TObject);
begin
     lstFontList.Clear;
     lstFontList.Items := Screen.Fonts;
     lstFontList.ItemIndex := 0;
     panSample.Caption := ediFont.Text;
     panSample.Font.Name := lstFontList.Items[0];
     lstFontList.SetFocus;
end;
//---->>>>


//#### bitExit -> OnClick
procedure TWFontBank32.bitExitClick(Sender: TObject);
begin
     Application.Terminate;
end;
//---->>>>


//#### sedSpin -> OnChange
procedure TWFontBank32.sedSpinChange(Sender: TObject);
begin
     panSample.Font.Size := sedSpin.Value;
     Information;
end;
//---->>>>


//#### radStyle -> OnClick
procedure TWFontBank32.radStyleClick(Sender: TObject);
begin
     case radStyle.ItemIndex of
          0: panSample.Font.Style := [];
          1: panSample.Font.Style := [fsBold];
          2: panSample.Font.Style := [fsItalic];
          3: panSample.Font.Style := [fsBold, fsItalic];
          4: panSample.Font.Style := [fsStrikeout];
          5: panSample.Font.Style := [fsUnderline];
     end;
     Information;
end;
//---->>>>


//#### cmbColor -> OnChange
procedure TWFontBank32.cmbColorChange(Sender: TObject);
begin
     case cmbColor.ItemIndex of
          0: panSample.Font.Color := clBlack;
          1: panSample.Font.Color := clMaroon;
          2: panSample.Font.Color := clGreen;
          3: panSample.Font.Color := clOlive;
          4: panSample.Font.Color := clNavy;
          5: panSample.Font.Color := clPurple;
          6: panSample.Font.Color := clTeal;
          7: panSample.Font.Color := clGray;
          8: panSample.Font.Color := clSilver;
          9: panSample.Font.Color := clRed;
          10: panSample.Font.Color := clLime;
          11: panSample.Font.Color := clYellow;
          12: panSample.Font.Color := clBlue;
          13: panSample.Font.Color := clFuchsia;
          14: panSample.Font.Color := clAqua;
          15: panSample.Font.Color := clWhite;
     end;
     Information;
end;
//---->>>>


//#### lstFontList -> OnClick
procedure TWFontBank32.lstFontListClick(Sender: TObject);
var
   TheFont: string;
begin
     panSample.Caption := ediFont.Text;
     TheFont:= lstFontlist.Items[lstFontList.ItemIndex];
     panSample.Font.Name := TheFont;
     Information;
end;
//---->>>>


//#### pagFonts -> OnChange
procedure TWFontBank32.pagFontsChange(Sender: TObject);
begin
     Resize;         // To Replace the Buttons
     If pagFonts.ActivePage = sheAbout then
        About1.Enabled := False
     else
         About1.Enabled := True;
end;
//---->>>>


//#### ediFont -> OnKeyPress
procedure TWFontBank32.ediFontKeyPress(Sender: TObject; var Key: Char);
begin
     if key = #13 then
        panSample.Caption := ediFont.Text;
end;
//---->>>>
//~~~~~~~~~~~~~~~~~~~ Form Objects ~~~~~~~~~~~~~~~~ Finish

end.
