//Created: 23.01.97
//Reused: 22.02.97 from Hintonent project
//Last Update: 06.03.97
//
unit UInvisible;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ExtCtrls, TrayIcon;

type
  TInvisible = class(TForm)
    popInvisible: TPopupMenu;
      Show1: TMenuItem;
      N1: TMenuItem;
      Exit1: TMenuItem;

    TrayIcon1: TTrayIcon;
    procedure FormCreate(Sender: TObject);
    procedure Show1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Invisible: TInvisible;

implementation

uses UFontBank32;

{$R *.DFM}


//~~~~~~~~~~~~~~~~~~~ Form Events ~~~~~~~~~~~~~~~~ Start
//~~~~OnCreate
procedure TInvisible.FormCreate(Sender: TObject);
begin
     If (PixelsPerInch = 96) or (PixelsPerInch = 120) then begin
        Left := -5000;  { move it off the screen because
                        it will flash on for a second
                        before the application processes
                        all the messages }
        ShowWindowAsync( Handle, SW_HIDE );
        WFontBank32 := TWFontBank32.Create(Application);
        end
     else Begin
          try
             MessageDlg('Terminating the application. Can''t work with your graphic resolution.',
                      mtInformation, [mbOk], 0);
          Finally
                 Application.Terminate;
                 end;
          end;
end;
//---->>>>
//~~~~~~~~~~~~~~~~~~~ Form Events ~~~~~~~~~~~~~~~~ Finish


//~~~~~~~~~~~~~~~~~~~ Form Popup Menu(s) ~~~~~~~~~~~~~~~~ Start
//#### Exit1
procedure TInvisible.Exit1Click(Sender: TObject);
begin
     Application.Terminate;
end;
//---->>>>


//#### Show1
procedure TInvisible.Show1Click(Sender: TObject);
begin
     if Show1.Caption = 'Show' then begin
        WFontBank32.Show;
        Show1.Caption := 'Hide';
        end
     else if Show1.Caption = 'Hide' then begin
          WFontBank32.Hide;
          Show1.Caption := 'Show';
          end;
end;
//---->>>>
//~~~~~~~~~~~~~~~~~~~ Form Popup Menu(s) ~~~~~~~~~~~~~~~~ Finish


//*********************************//
//*** Application's Start Point ***//
//*********************************//

Initialization
begin
   //~~ We want to hide the application TASKBAR icon
   ShowWindow( Application.Handle, SW_HIDE );
   Application.ProcessMessages;
end;

end.
